<p align="center"><img <p align="center"><img width="100"src="../../Deploy/logo.png"></p>

# Applications Made with Neutronium


## Kryptex

Kryptex is a smart cryptocurrency mining app with bitcoin payouts (closed-source).
https://www.kryptex.org/

<img src="../images/Example/kryptex.png" width="400px"><br>

See why they choosed Neutronium [here](https://github.com/NeutroniumCore/Neutronium/issues/12)


## ReactiveTrader Neutronium
[https://github.com/David-Desmaisons/ReactiveTrader/tree/neutronium_implementation](https://github.com/David-Desmaisons/ReactiveTrader/tree/neutronium_implementation)

Alternative UI for [ReativeTrade application](https://github.com/AdaptiveConsulting/ReactiveTrader). 


<img src="../images/Example/reactive-trader.gif" width="650px">><br>
<img src="../images/Example/reactive trader.png" width="650px">><br>
<img src="../images/Example/reactive trader-2.png" width="650px">><br>


## Music.Cover.Finder
[https://github.com/David-Desmaisons/Music.Cover.Finder](https://github.com/David-Desmaisons/Music.Cover.Finder)

Application to Find disc cover art based on [discogs API](https://www.discogs.com/). Based on `Neutronium.SPA.Demo`.

<img src="../images/Example/MusicCoverFinder.png" width="650px">><br>


## CodeDependencyScaner
[https://github.com/NeutroniumCore/CodeDependencyScanner](https://github.com/NeutroniumCore/CodeDependencyScanner)

Codegravity is a demonstration application (working still in progress) showcasing neutronium + Vue + D3.js in context of C# code analysis.

<img src="../images/Example/codedependency.png" width="650px">><br>


## Neutronium.SPA.Demo
[https://github.com/NeutroniumCore/Neutronium.SPA.Demo](https://github.com/NeutroniumCore/Neutronium.SPA.Demo)

Neutronium.SPA.Demo is a scaffold Vue.js reference project that can be used as a starter or reference when building a large project.
It includes IoC (example Ninject but easily changeable), navigation with integration with vue-router, internalization with integration with vue-i18n. Built on top of Vuetify.js.

<img src="../images/Example/SPA.Demo.png" width="650px"><br>

## NeutroniumDemo
[https://github.com/NeutroniumCore/NeutroniumDemo](https://github.com/NeutroniumCore/NeutroniumDemo)

NeutroniumDemo is a scaffold project including logging, IoC, navigation, demonstrating how you can structure/architecture a project with neutronium.
It is using [navigation API](./Navigation.md) to navigate between ViewModels. 


[How to set up a project](./SetUp.md) - [Overview](./Overview.md) - [Architecture](./Architecture.md) - [F.A.Q](./FAQ.md)
